import axios from 'axios'
import client from '../managers/client'
import auth from '../managers/auth'

let extension = client.getClient().prod ? 'com/' : 'xyz/'

let config = {
    baseURL: 'https://auth.marketplays.' + extension,
    headers: {
        'Accept': 'application/json',
        'HTTP_X_MP_LANGUAGE': client.getClient().locale,
        'Content-Type': 'application/x-www-form-urlencoded'
    }
}

const instance = axios.create(config)

// interceptors
const resInterceptors = instance.interceptors.response.use(res => {
    return res
}, error => {
    if (error.response.status === 401) {
        ejectInterceptors()
        return new Promise(function (resolve, reject) {
            auth.refreshToken()
                .then(response => {
                    error.config.headers['Authorization'] = `Bearer ${response.data.access_token}`
                    return instance.request(error.config)
                })
                .then(reqResult => {
                    resolve(reqResult)
                })
                .catch(error => {
                    reject(error)
                })
        })
    }
})

function ejectInterceptors() {
    instance.interceptors.response.eject(resInterceptors)
}

/*
instance.defaults.headers.common['Accept'] = 'application/json'
instance.defaults.headers.common['HTTP_X_MP_LANGUAGE'] = client.getClient().locale
instance.defaults.headers.common['Content-Type'] = 'application/x-www-form-urlencoded'
*/

export default instance